/* tree.h

   07/26/01
                                                                           */

#ifndef TREE_H__
#define TREE_H__

#include"smlng.h"
#include"token.h"


typedef struct _node
{
   Token *token;        /* Token at current node */
   struct _node *next;  /* Pointer to sibling */
   struct _node *tree;  /* Pointer to subtree */

   Attr attr;           /* Attributes */

} Node;

Node *CreateParseTree(Input *input);
void DeleteNode(Node **node);
void DeleteParseTree(Node *root);
void DumpTree(Node *node, FILE *output);
void PromoteSubtree(Node **node);


#endif
